/**
 * Insulates from specific libraries for constructing & executing REST requests.
 */

/* 
 * REST GET osapi.
 * 
 * @url is the url of the REST resource.
 * @headers are the headers to include in the request
 * @params are the parameters to include in the request
 * @callback(resp) is the callback function to receive the response
 */
/*
 * REST GET jQuery.
 */
/*
 * REST GET jQuery.
 */
function get(url, headers, params, callback) {
	console.log('ajax get: ' + url);
	console.log(headers);
	$.ajax({
		url: url,
		headers: headers,
		data: params,
		dataType: 'json',
		success: function(resp) {
			console.log('request successful');
			callback(resp);
		},
		error: function(resp) {
			console.log('request failed');
			console.log(resp);
			callback(null);
		}
	});
}

function post(url, headers, params, callback) {
	console.log('ajax post: ' + url);
	console.log(headers);
	$.ajax({
		url: url,
		type: 'POST',
		headers: headers,
		data: params,
		dataType: 'json',
		success: function(resp) {
			console.log('request successful');
			callback(resp);
		},
		error: function(resp) {
			console.log('request failed');
			console.log(resp);
			callback(null);
		}
	});
}

function httpDelete(url, headers, params, callback) {
	console.log('ajax delete: ' + url);
	console.log(headers);
	$.ajax({
		url: url,
		type: 'DELETE',
		headers: headers,
		data: params,
		dataType: 'json',
		success: function(resp) {
			console.log('request successful');
			callback(resp);
		},
		error: function(resp) {
			console.log('request failed');
			console.log(resp);
			callback(null);
		}
	});
}

/* 
 * REST GET osapi.
 * 
 * @url is the url of the REST resource.
 * @headers are the headers to include in the request
 * @params are the parameters to include in the request
 * @callback(resp) is the callback function to receive the response
 */
function getOsapi(url, headers, params, callback) {
	console.log('get:' + url);
	var osHeaders = {};
	for (var key in headers) {
		osHeaders[key] = [headers[key]];
	}
	osapi.http.get({
		'href' : url,
		'headers' : osHeaders,
		'refreshInterval' : 0
	}).execute(function(resp) {
		callback(JSON.parse(resp.content));
	});
}